/////////////////////////////////////////////////////////
//  * Der Panzergeneral 2 - Version 1.5 - Quellcode *  //
//  -------------------------------------------------  //
//  Entwicklung: Michael Dpjohann & Daniel Marschall. //
//  -------------------------------------------------  //
//  (C)Copyright 2000 - 2005 ViaThinkSoft.             //
//  Alle Rechte vorbehalten.                           //
/////////////////////////////////////////////////////////

program DPG2;

uses
  Windows,
  Messages,
  SysUtils,
  Controls,
  Forms,
  Dialogs,
  System.UITypes,
  DpgMenu in 'DpgMenu.pas' {MenuForm},
  DpgGame in 'DpgGame.pas' {SpielForm},
  DpgHilfe in 'DpgHilfe.pas' {HilfeForm},
  DpgSettings in 'DpgSettings.pas' {EinstellungForm},
  DpgSplash in 'DpgSplash.pas' {SplashForm},
  DPGGlobal in 'DPGGlobal.pas';

{$R *.RES}

var
  Sem: THandle;
  Fehler: boolean;

procedure Counter(progress: integer);
begin
  splashform.ProgressGge.Progress := splashform.ProgressGge.Progress + progress;
end;

begin
  { Programm schon gestartet? }
  Sem := CreateSemaphore(nil, 0, 1, 'Der Panzergeneral 2');
  if (Sem <> 0) and (GetLastError = ERROR_ALREADY_EXISTS) then
  begin
    CloseHandle(Sem);
    MessageDlg('Das Spiel wurde bereits gestartet.', mtInformation, [mbOK], 0);
    exit;
  end;
  { Verzeichnis ermitteln }
  directory := extractfilepath(paramstr(0));
  { Programm vorbereiten! }
  SplashForm := TSplashForm.Create(Application);
  SplashForm.Show;
  SplashForm.Update;
  Application.Initialize;
  Application.Title := 'Der Panzergeneral 2';
  Application.MainFormOnTaskBar := true;
  Application.ShowMainForm := false;
  { Dateien vorhanden? }
  Fehler := false;
  if not fileexists(directory+'Bilder\Abbrechen.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Blatt.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Bltter.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Brief.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Buch.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Fragezeichen.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Hintergrund.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Neustart.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\OK.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Standard.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Sterne.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Tastatur.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Verlassen.bmp') then Fehler := true;
  if not fileexists(directory+'Bilder\Weltkugel.bmp') then Fehler := true;
  if not fileexists(directory+'DirectX\Grafik.dxg') then Fehler := true;
  if not fileexists(directory+'DirectX\Audio.dxw') then Fehler := true;
  if not fileexists(directory+'Musik\Freegamer.mid') then Fehler := true;
  if not fileexists(directory+'Musik\Musik1.mid') then Fehler := true;
  if not fileexists(directory+'Musik\Musik2.mid') then Fehler := true;
  if not fileexists(directory+'Musik\Musik3.mid') then Fehler := true;
  if not fileexists(directory+'Musik\Musik4.mid') then Fehler := true;
  if not fileexists(directory+'Musik\Musik5.mid') then Fehler := true;
  if not fileexists(directory+'Texte\Geschichte.txt') then Fehler := true;
  if not fileexists(directory+'Texte\Informationen.txt') then Fehler := true;
  if not fileexists(directory+'Texte\Mitwirkende.txt') then Fehler := true;
  if not fileexists(directory+'Texte\Steuerung.txt') then Fehler := true;
  if not fileexists(directory+'Texte\Ziel.txt') then Fehler := true;
  if Fehler then
  begin
    MessageDLG('Dateien, die die Programmstabilitt gewhrleisten, sind ' +
      'nicht mehr vorhanden!'+#13#10+'Bitte installieren Sie DPG II erneut...',
      mtWarning, [mbOK], 0);
    exit;
  end;
  { Keine Soundkarte?! }
  if not soundkarte then
    MessageDlg('Es wurde keine Soundkarte gefunden!' + #13#10 +
    'Entweder ist keine Soundkarte angeschlossen oder sie ist nicht ' +
    'ordnungsgem installiert.' + #13#10 + 'Es knnen daher keine Musik und ' +
    'keine Gerusche abgespielt werden.', mtError, [mbOK], 0);
  { Programm starten! }
  counter(1);
  Application.CreateForm(TMenuForm, MenuForm);
  counter(1);
  Application.CreateForm(TSpielForm, SpielForm);
  counter(1);
  Application.CreateForm(THilfeForm, HilfeForm);
  counter(1);
  Application.CreateForm(TEinstellungForm, EinstellungForm);
  counter(1);
  EinstellungForm.LoadINI;
  counter(1);
  SplashForm.Hide;
  FreeAndNil(SplashForm);
  MenuForm.Visible := true;
  Application.Run;
end.

